/*** private */

function ciAdjustInputs(rinputs,pinputs)
{
	for(var i=0;i<rinputs.length;++i)
	{
		var input = rinputs[i];
		if (input.type == 'text' || input.type == 'hidden')
		{
			var nvalue = nodeFindByName(pinputs,input.name);
			if (nvalue)
				input.defaultValue = input.value = nvalue.getAttribute('value');


		}
		else if (input.type == 'checkbox')
		{
			var nvalue = nodeFindByNameValue(pinputs,input.name,input.value);
			if (nvalue)//Note: there are no  hasAttribute function in IE
				input.defaultChecked = input.checked = nvalue.getAttribute('checked')?true:false;
		}
	}
}

function ciAdjustTextAreas(rinputs,pinputs)
{
	for(var i=0;i<rinputs.length;++i)
	{
		var input = rinputs[i];
		var nvalue = nodeFindByName(pinputs,input.name);
		if (nvalue)
		   input.defaultValue = input.value = nodeText(nvalue);
	}
}

function ciAdjustSelects(rselects,pselects)
{

	function clearOptions(select)
	{
		while(select.length > 0)
			select.remove(select.length - 1);
	}
	
	function setupOptions(select,options)
	{
		for(var i = 0;i<options.length;++i)
		{
			var item = document.createElement('option');
			item.text = nodeText(options[i]);
			item.value = options[i].getAttribute('value');
			item.defaultSelected = item.selected = options[i].getAttribute('selected')?true:false;
			try{
				select.add(item,null);
			}catch(ex)
			{
				select.add(item);
			}
		}
	}
	
	for(var i = 0;i<rselects.length;++i)
	{
		var select = rselects[i];
		var nvalue = nodeFindByName(pselects,select.name);
		if (!nvalue) continue;
		clearOptions(select);
		setupOptions(select,nvalue.getElementsByTagName('option'));
	}
}

function ciAdjustAnchors(anchors,target)
{
    if (!target) return;    

    var path=document.location.protocol +
             '//' +
	     document.location.host ;

    for(var i=0;i<anchors.length;++i)
    {
	var item = anchors[i];
	if ('alterator-ref2' == nodeClass(item))
	    item.setAttribute('href', path + item.getAttribute('href2') + '/' + target);
    }
}

function ciAdjustSpans(rspans,pspans)
{
    // span arrays may be different (because of translation spans)
    var pi=0;
    for (var ri=0; ri<rspans.length; ri++){
	if ('alterator-label' != nodeClass(rspans[ri])) continue;
        while (('alterator-label' != nodeClass(pspans[pi])) && (pi<pspans.length)) pi++
	rspans[ri].innerHTML = nodeText(pspans[pi]);
        pi++;
    }
}

function ciAdjustAnchors(ranchors,panchors)
{
    for(var i=0;i<ranchors.length;++i)
    {
        if ('alterator-ref2' != nodeClass(ranchors[i])) continue;
        var pitem = panchors[i];
        var ritem = ranchors[i];
        ritem.setAttribute('href',pitem.getAttribute('href'));
    }
}


function ciAdjust(page)
{
	//we assume that we only update field state here, no page changes
	var pforms = page.getElementsByTagName('form');
	var rforms = document.getElementsByTagName('form');

	if (pforms.length != rforms.length) return;

	for(var i=0;i<pforms.length;++i)
	{
		var pclass = pforms[i].getAttribute('class');
		if (pclass == "selector-chooser" || pclass != rforms[i].className)
			continue;
		var current_pform = pforms[i];
		var current_rform = rforms[i];
		//select all normal inputs
		ciAdjustInputs(current_rform.getElementsByTagName('input'),
		                    current_pform.getElementsByTagName('input'));
		ciAdjustTextAreas(current_rform.getElementsByTagName('textarea'),
		                       current_pform.getElementsByTagName('textarea'));
		ciAdjustSelects(current_rform.getElementsByTagName('select'),
		                     current_pform.getElementsByTagName('select'));
		ciAdjustSpans(current_rform.getElementsByTagName('span'),
		                     current_pform.getElementsByTagName('span'));
		ciAdjustAnchors(current_rform.getElementsByTagName('a'),
		                current_pform.getElementsByTagName('a'));
	}
	
	updateEffect();
}

/*** constructor */
var ciInitialized = false;

function ciInit()
{
	if (ciInitialized) return;
	ciInitialized = true;

	var has_async = makeXMLHttpRequest();
	if (!has_async) return;

	var form = document.getElementById('ajax-selector');
	if (!form) return;

	var button = form.elements['card-index-select'];
	if (button) button.style.display='none';

	var selector = form.elements['name'];
	if (!selector ||  !selector.nodeName) return;

	addEvent(selector,'change',function() {ajaxSubmit(ciAdjust,'ajax-selector','POST');});

	delete has_async;
}

addEvent(window,'load',ciInit);
