/*** common effect functions */

function effAdd(slist, tlist, fieldname, targetname, targetvalue)
{
    tlist[targetname]=1;

    if (!slist[fieldname]) slist[fieldname]={};
    if (!slist[fieldname][targetname]) slist[fieldname][targetname]=[];
    slist[fieldname][targetname].push(targetvalue);
}

function form_get_input(name)
{
    return $("input,select,textarea").filter("[name="+name+"]");
}

jQuery.fn.form_val=function(useDefault)
{
    if (!this.length) return undefined;

    var input = this[0];

    if (input.type == "checkbox")
	    return useDefault?input.defaultChecked:input.checked;
    else if (jQuery.nodeName(input,"select"))
    {
	var idx=input.selectedIndex;
	if (useDefault)
	for (var i=0;i<input.options.length;++i)
	    if (input.options[i].defaultSelected)
	    {
		idx = i;
		break;
	    }

	return (idx >= 0) && input.options[idx] && input.options[idx].value;
    }
    else
	return useDefault?input.defaultValue:input.value;
}

function form_input_get_value(name,useDefault)
{
    return form_get_input(name).form_val(useDefault);
}

function effNeed(rules,useDefault)
{
	for(var i in rules)
	{
		if (arrayContains(rules[i],form_input_get_value(i,useDefault))) return true;
	}
	return false;
}

function effCheck(graph,proc,useDefault)
{
	for (var i in graph)
	{
		var need = effNeed(graph[i],useDefault);
		proc(i,need);
	}
}

function effInit(tlist,check)
{
	for (var i in tlist)
		form_get_input(i).change(function() { check(false); });

	$("form").bind("reset", function() { check(true); });

	check(false);
}

/*** effect: Disable */

var effDisableSList={}; /* main graph */
var effDisableTList={}; /* helper to avoid dups in callbacks */

function effectDisable(fieldname, targetname, targetvalue)
{
    effAdd(effDisableSList,effDisableTList,fieldname, targetname, targetvalue);
}

function effDisableDo(name,need)
{
    var elems = $("[name="+name+"]");

    if (need)
	elems.addClass('disabled');
    else
	elems.removeClass('disabled');

    elems.each(function() { this.disabled = need  });
}

function effDisableCheck(useDefault)
{
    effCheck(effDisableSList,effDisableDo,useDefault);
}

/*** effect: Enable */

var effEnableSList={}; /* main graph */
var effEnableTList={}; /* helper to avoid dups in callbacks */

function effectEnable(fieldname, targetname, targetvalue)
{
    effAdd(effEnableSList,effEnableTList,fieldname, targetname, targetvalue);
}

function effEnableCheck(useDefault)
{
    effCheck(effEnableSList,function(name,need) { effDisableDo(name,!need); },useDefault);
}

/*** effect: Show */

var effShowSList={}; /* main graph */
var effShowTList={}; /* helper to avoid dups in callbacks */

function effectShow(fieldname, targetname, targetvalue)
{
    effAdd(effShowSList,effShowTList,fieldname, targetname, targetvalue);
}

function effShowDo(name,need)
{
    var elems = $("[name="+name+"]");

    if (need)
	elems.show();
    else
	elems.hide();
}

function effShowCheck(useDefault)
{
    effCheck(effShowSList,effShowDo,useDefault);
}

/*** effect: Hide */

var effHideSList={}; /* main graph */
var effHideTList={}; /* helper to avoid dups in callbacks */

function effectHide(fieldname, targetname, targetvalue)
{
    effAdd(effHideSList,effHideTList,fieldname, targetname, targetvalue);
}

function effHideCheck(useDefault)
{
    effCheck(effHideSList, function(name,need) { effShowDo(name,!need); }, useDefault);
}

/*** constructor */
function updateEffect()
{
	effDisableCheck(false);
	effEnableCheck(false);
	effHideCheck(false);
	effShowCheck(false);
}

function initEffect()
{
	effInit(effDisableTList,effDisableCheck);
	effInit(effEnableTList,effEnableCheck);
	effInit(effShowTList,effShowCheck);
	effInit(effHideTList,effHideCheck);
}

$(document).ready(initEffect);
