/*** private */

function fAdjustInputs(rinputs,pinputs)
{
	for(var i=0;i<rinputs.length;++i)
	{
		var input = rinputs[i];
		if (input.type == 'text' || input.type == 'hidden')
		{
			var nvalue = nodeFindByName(pinputs,input.name);
			if (nvalue)
				input.defaultValue = input.value = nvalue.getAttribute('value');


		}
		else if (input.type == 'checkbox')
		{
			var nvalue = nodeFindByNameValue(pinputs,input.name,input.value);
			if (nvalue)//Note: there are no  hasAttribute function in IE
				input.defaultChecked = input.checked = nvalue.getAttribute('checked')?true:false;
		}
	}
}

function fAdjustTextAreas(rinputs,pinputs)
{
	for(var i=0;i<rinputs.length;++i)
	{
		var input = rinputs[i];
		var nvalue = nodeFindByName(pinputs,input.name);
		if (nvalue)
		   input.defaultValue = input.value = nodeText(nvalue);
	}
}

function fAdjustSelects(rselects,pselects)
{

	function clearOptions(select)
	{
		while(select.length > 0)
			select.remove(select.length - 1);
	}
	
	function setupOptions(select,options)
	{
		for(var i = 0;i<options.length;++i)
		{
			var item = document.createElement('option');
			item.text = nodeText(options[i]);
			item.value = options[i].getAttribute('value');
			item.defaultSelected = item.selected = options[i].getAttribute('selected')?true:false;
			try{
				select.add(item,null);
			}catch(ex)
			{
				select.add(item);
			}
		}
	}
	
	for(var i = 0;i<rselects.length;++i)
	{
		var select = rselects[i];
		var nvalue = nodeFindByName(pselects,select.name);
		if (!nvalue) continue;
		clearOptions(select);
		setupOptions(select,nvalue.getElementsByTagName('option'));
	}
}

function fAdjustAnchors(ranchors,panchors)
{
    for(var i=0;i<ranchors.length;++i)
    {
        if ('alterator-ref2' != nodeClass(ranchors[i])) continue;
        var pitem = panchors[i];
        var ritem = ranchors[i];
        ritem.setAttribute('href',pitem.getAttribute('href'));
    }
}

function fAdjustSpans(rspans,pspans)
{
    // span arrays may be different (because of translation spans)
    var pi=0;
    for (var ri=0; ri<rspans.length; ri++){
	if ('alterator-label' != nodeClass(rspans[ri])) continue;
        while (('alterator-label' != nodeClass(pspans[pi])) && (pi<pspans.length)) pi++
	rspans[ri].innerHTML = nodeText(pspans[pi]);
        pi++;
    }
}

function fAdjust(page)
{
	//we assume that we only update field state here, no page changes
	var pforms = page.getElementsByTagName('form');
	var rforms = document.getElementsByTagName('form');

	if (pforms.length != rforms.length) return;

	for(var i=0;i<pforms.length;++i)
	{
		var current_pform = pforms[i];
		var current_rform = rforms[i];
		//select all normal inputs
		fAdjustInputs(current_rform.getElementsByTagName('input'),
		                    current_pform.getElementsByTagName('input'));
		fAdjustTextAreas(current_rform.getElementsByTagName('textarea'),
		                       current_pform.getElementsByTagName('textarea'));
		fAdjustSelects(current_rform.getElementsByTagName('select'),
		                     current_pform.getElementsByTagName('select'));
		fAdjustSpans(current_rform.getElementsByTagName('span'),
		                     current_pform.getElementsByTagName('span'));
		fAdjustAnchors(current_rform.getElementsByTagName('a'),
		               current_pform.getElementsByTagName('a'));
	}
	
	document.body.style.cursor='default';
	document.forms[0].elements['name'].style.cursor='default';

	updateEffect();
}

/*** constructor */

function fInit()
{
	var has_async = makeXMLHttpRequest();
	if (!has_async) return;

	var form = document.getElementById('ajax-select');
	if (!form) return;

	var select = form.elements['name'];
	var button = form.elements['select'];

	if (!select || !button) return;

	addEvent(select,'change',function() {   document.body.style.cursor='wait';
						document.forms[0].elements['name'].style.cursor='wait';
						ajaxSubmit(fAdjust,form,'POST');});
	button.style.display='none';

	delete has_async;
}

addEvent(window,'load', fInit);
