function ajaxGetInputValue(input)
{
	if (input.nodeName.toLowerCase() == 'input')
	{
		if (input.type == "checkbox" && !input.checked)
		    return null;
		else	
		    return input.value;
	}
	else if (input.nodeName.toLowerCase() == 'select')
		return  (input.selectedIndex >= 0) &&
			input.options[input.selectedIndex] &&
		        input.options[input.selectedIndex].value;
}

function ajaxMakePostString(form)
{
	if (!form) return '';

	var values=[];
	var elements = form.elements;
	
	//simulate pressing to select button
	for (var i=0;i<elements.length;++i)
	{
		if (elements[i].type == 'submit' || elements[i].type == 'reset') continue;
		var value = ajaxGetInputValue(elements[i]);
		if (!value) continue;
		values.push(encodeURIComponent(elements[i].name)+'='+encodeURIComponent(value));
	}

	return values.join('&');
}

function ajaxSubmit(callback,form,method)
{
	var form = (typeof form == 'string')?document.getElementById(form):form;
	var method = method || 'GET';

	var xmlhttp = makeXMLHttpRequest();
	if (!xmlhttp) return;

	var path = '';
	//reconstruct url: document.location.href can contain broken url, e.g. with ? at the end
	with (document.location)
	    path = protocol + '//' +
		    host + pathname +
		    search + ((document.location.search)?'&':'?') +
		    'async=yes&msienocache='+ Math.random();

	xmlhttp.open(method, path, true);
	
	var request='';
	
	if (method == 'POST' && form)
	{
	    xmlhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
	    request = ajaxMakePostString(form);
	}
	
	xmlhttp.onreadystatechange = function()
				    {
					if (xmlhttp.readyState == 4)
					{
					    var answer = xmlhttp.responseXML;
					    if (xmlhttp.status == 200 && answer) callback(answer);
					    delete xmlhttp;
				     	};
				    };
	xmlhttp.send(request);
}
