/*** private */

var teInterval = 15000;
var teIntervalID ;
var teNeedUpdate = false;

var teList = {};

/*** date format */
function teNumberString(n)
{
    return (n < 10)? '0'+ n: n
}

function teString(clock)
{
    var date = clock.now;
    var h = date.getHours();
    var m = date.getMinutes();
    var s = date.getSeconds();

    return teNumberString(h) + ':'
	   +teNumberString(m) + ':'
	   +teNumberString(s);
}

/* date update */

function teValue(input)
{
    if (!input) return new Date(1,1,1);

    var v = input.value || input.getAttribute('value');//preffer real value
    var vlist = v.split(':');
    return new Date(1,1,1,
		    vlist[0] || 0,
		    vlist[1] || 0,
		    vlist[2] || 0);
}

function teUpdateStart()
{
    window.setTimeout (function () { ajaxSubmit(teUpdateAll); }, teInterval);
}

function teUpdateClock(document,name)
{
    var clock = teList[name];

    var input = nodeFindByName(document.getElementsByTagName('input'),name);
    clock.now = teValue(input);
    clock.refreshDisplay();

    input.value = teString(clock);
}


function teUpdateAll(document)
{
	for(i in teList)
	    if (!teList[i].frozen) teUpdateClock(document,i);

	teUpdateStart();
}

/*** constructor */
function teCreate(name)
{
    var input = nodeFindByName(document.getElementsByTagName('input'),name);
    var clock = new CoolClock(name+'-canvas');

    if (!clock || !input) return;

    teList[name]=clock;

    //automatic update && freeze
    clock.onTick = function(obj) { if (!input.hasFocus && !input.wasChanged) input.value = teString(obj); }

    addEvent(input,'focus', function() { input.hasFocus = true; clock.stop(); })
    addEvent(input,'blur', function() { input.hasFocus = false; if (!input.wasChanged) clock.start(); })
    addEvent(input,'change', function() { input.wasChanged = true; teUpdateClock(document,name); })
    teUpdateClock(document,name);

    teNeedUpdate = true;
}

/* explorer canvas is ready to use only after page load */
function teCreateOnLoad(name)
{
    addEvent(window,"load",function() { teCreate(name); });
}

function teInit()
{
    if (teNeedUpdate) teUpdateStart();
}

addEvent(window,"load",teInit);
