(define-module (alterator http path)
  :use-module (srfi srfi-1)
  :use-module (alterator algo)
  :export (open-path))

(define (open/ignore path)
  (catch/ignore
    'system-error
    (lambda() (open-input-file path))))

(define (object-type x)
  (stat:type (stat x)))

(define (open-index prefix)
  (lambda (idx)
    (let ((port (open/ignore (string-append prefix "/" idx))))
      (and (port? port)
	   (case (object-type port)
	     ((regular)
	      port)
	     (else
	       (close-port port)
	       #f))))))

(define (open-path location root indexlist)
  (let* ((prefix (string-append root "/" location))
	 (port (open/ignore prefix)))
    (and (port? port)
	 (case (object-type port)
	   ((regular)
	    port)
	   ((directory)
	    (close-port port)
	    (any (open-index prefix)
		 indexlist))
	   (else
	     (close-port port)
	     #f)))))
